/**
 *  Copyright (c) 1997-2013, tinygroup.org (luo_guo@live.cn).
 *
 *  Licensed under the GPL, Version 3.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *       http://www.gnu.org/licenses/gpl.html
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 * --------------------------------------------------------------------------
 *  版权 (c) 1997-2013, tinygroup.org (luo_guo@live.cn).
 *
 *  本开源软件遵循 GPL 3.0 协议;
 *  如果您不遵循此协议，则不被允许使用此文件。
 *  你可以从下面的地址获取完整的协议文本
 *
 *       http://www.gnu.org/licenses/gpl.html
 */
package org.tinygroup.bumgt.cmd;

import org.tinygroup.bu.BusinessUnitManager;
import org.tinygroup.bu.BusinessUnitManagerFactory;
import org.tinygroup.bu.config.BusinessUnitInfo;
import org.tinygroup.command.CommandGoalExecutor;
import org.tinygroup.command.CommandSystem;
import org.tinygroup.context.Context;

public class BuRemoveCommand implements CommandGoalExecutor {
	private String name;
	private String packageName;
	private String version;
	
	
	public String getName() {
		return name;
	}


	public void setName(String name) {
		this.name = name;
	}


	public String getPackageName() {
		return packageName;
	}


	public void setPackageName(String packageName) {
		this.packageName = packageName;
	}


	public String getVersion() {
		return version;
	}


	public void setVersion(String version) {
		this.version = version;
	}

	private boolean isNull(String string) {
		return string == null || "".equals(string);
	}
	public void execute(CommandSystem commandHelper, Context context) {
		if(isNull(packageName)){
			commandHelper.indentPrint("参数packageName不可为空", 0);
			commandHelper.println();
		}else if(isNull(name)){
			commandHelper.indentPrint("参数name不可为空", 0);
			commandHelper.println();
		}else if(isNull(version)){
			commandHelper.indentPrint("参数version不可为空", 0);
			commandHelper.println();
		}
		BusinessUnitManager buMananger = BusinessUnitManagerFactory.getManager();
		BusinessUnitInfo bu = buMananger.getBusinessUnitInfo(packageName, name, version);
		if(bu==null){
			commandHelper.indentPrint(
					String.format("业务单元[package:%s,name:%s,version:%s]不存在",packageName,name,version),
					0);
			commandHelper.println();
		}
		buMananger.uninstall(packageName, name, version);
	}

}
